diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index d2caf6866..a238adc9a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -32,590 +32,571 @@ import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
-
-public abstract class ScreenContainerAbstract extends Screen
-{
-	public int xSize;
-	public int ySize;
-	public MenuAbstract inventorySlots;
-	public TooltipElement tooltipElement;
-	public ItemElement itemElement;
-	public ItemDragHandler itemDragHandler;
-
-	public ScreenContainerAbstract(final MenuAbstract container)
-	{
-		Minecraft mc = Minecraft.getMinecraft();
-		xSize = 176;
-		ySize = 166;
-		inventorySlots = container;
-		tooltipElement = new TooltipElement(mc);
-		itemElement = new ItemElement(mc);
-		itemDragHandler = new ItemDragHandler(mc, this, itemElement);
-	}
-
-	@Override
-	public boolean isPauseScreen()
-	{
-		return false;
-	}
-
-	protected abstract void drawGuiContainerBackgroundLayer(float f);
-
-	protected void drawGuiContainerForegroundLayer()
-	{
-	}
-
-	@Override
-	public void render(final int mx, final int my, final float partialTick)
-	{
-		renderBackground();
-		final int centerX = (width - xSize) / 2;
-		final int centerY = (height - ySize) / 2;
-		drawGuiContainerBackgroundLayer(partialTick);
-		GL11.glPushMatrix();
-		GL11.glTranslatef(centerX, centerY, 0.0F);
-		drawGuiContainerForegroundLayer();
-		Slot slot = null;
-		for (int i = 0; i < inventorySlots.slots.size(); i++)
-		{
-			final Slot slot1 = inventorySlots.slots.get(i);
-			boolean mouseOver = getIsMouseOverSlot(slot1, mx, my);
-			if(!itemDragHandler.isSlotDragged(slot1)) {
-				itemElement.render(slot1.getItemStack(), slot1.x, slot1.y, mouseOver, slot1);
-			}
-			if (mouseOver)
-			{
-				slot = slot1;
-			}
-		}
-
-		final ContainerInventory inventoryplayer = mc.thePlayer.inventory;
-		ItemStack grabbedItem = inventoryplayer.getHeldItemStack();
-		if(mc.gameSettings.enableItemDragging.value) {
-			itemDragHandler.drawScreen(mx, my, partialTick);
-
-			ItemStack grabbedItemOverride = itemDragHandler.getHeldItemRenderOverride();
-			if(grabbedItemOverride != null) {
-				grabbedItem = grabbedItemOverride;
-			}
-		}
-		GL11.glPopMatrix();
-
-		super.render(mx, my, partialTick);
-
-		GL11.glPushMatrix();
-		if (grabbedItem != null)
-		{
-			GL11.glTranslatef(centerX, centerY, 100.0F);
-			itemElement.render(grabbedItem, mx - centerX - 8, my - centerY - 8);
-		}
-		GL11.glPopMatrix();
-
-		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-		if (inventoryplayer.getHeldItemStack() == null && slot != null && slot.hasItem())
-		{
-			boolean showDescription = DescriptionPromptEnum.showDescription(mc);
-			String str = tooltipElement.getTooltipText(slot.getItemStack(), showDescription, slot);
-			if(str.length() > 0)
-			{
-				tooltipElement.render(str, mx, my, 8, -8);
-			}
-		}
-		GL11.glEnable(GL11.GL_DEPTH_TEST);
-	}
-
-	public boolean getIsMouseOverSlot(final Slot slot, int i, int j)
-	{
-		final int k = (width - xSize) / 2;
-		final int l = (height - ySize) / 2;
-		i -= k;
-		j -= l;
-		return i >= slot.x - 1 && i < slot.x + 16 + 1 && j >= slot.y - 1 && j < slot.y + 16 + 1;
-	}
-
-	public Slot getSlotAtPosition(final int i, final int j)
-	{
-		for (int k = 0; k < inventorySlots.slots.size(); k++)
-		{
-			final Slot slot = (Slot) inventorySlots.slots.get(k);
-			if (getIsMouseOverSlot(slot, i, j))
-			{
-				return slot;
-			}
-		}
-
-		return null;
-	}
-
-	@Override
-	public void init()
-	{
-		super.init();
-		mc.thePlayer.craftingInventory = inventorySlots;
-	}
-
-	@Override
-	public void keyPressed(final char eventCharacter, final int eventKey, int mx, int my)
-	{
-		if (eventKey == Keyboard.KEY_ESCAPE || eventKey == Keyboard.KEY_BACK)
-		{
-			mc.thePlayer.closeScreen();
-		}
-		int slotId = getSlotId(mx, my);
-		checkKeybind(slotId, eventKey, -1);
-	}
-
-	public boolean checkKeybind(int slotId, int key, int mouseButton) {
-		boolean cancelClick = false;
-		if (mc.gameSettings.keyInventory.isKeyOrMouse(key, mouseButton))
-		{
-			mc.thePlayer.closeScreen();
-			cancelClick = true;
-		}
-		if(slotId >= 0) {
-			if(mc.gameSettings.keyShowRecipe.isKeyOrMouse(key, mouseButton)){
-				Slot slot = inventorySlots.slots.get(slotId);
-				if(slot.hasItem()){
-					String query = "r:"+slot.getItemStack().getDisplayName()+"!";
+
+public abstract class ScreenContainerAbstract extends Screen {
+    public int xSize;
+    public int ySize;
+    public MenuAbstract inventorySlots;
+    public TooltipElement tooltipElement;
+    public ItemElement itemElement;
+    public ItemDragHandler itemDragHandler;
+
+    public ScreenContainerAbstract(final MenuAbstract container) {
+        Minecraft mc = Minecraft.getMinecraft();
+        this.xSize = 176;
+        this.ySize = 166;
+        this.inventorySlots = container;
+        this.tooltipElement = new TooltipElement(mc);
+        this.itemElement = new ItemElement(mc);
+        this.itemDragHandler = new ItemDragHandler(mc, this, this.itemElement);
+    }
+
+    @Override
+    public boolean isPauseScreen() {
+        return false;
+    }
+
+    protected abstract void drawGuiContainerBackgroundLayer(float f);
+
+    protected void drawGuiContainerForegroundLayer() {
+    }
+
+    @Override
+    public void render(final int mx, final int my, final float partialTick) {
+        renderBackground();
+        final int centerX = (this.width - this.xSize) / 2;
+        final int centerY = (this.height - this.ySize) / 2;
+        drawGuiContainerBackgroundLayer(partialTick);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(centerX, centerY, 0.0F);
+        drawGuiContainerForegroundLayer();
+        Slot slot = null;
+        for (int i = 0; i < this.inventorySlots.slots.size(); i++) {
+            final Slot slot1 = this.inventorySlots.slots.get(i);
+            boolean mouseOver = getIsMouseOverSlot(slot1, mx, my);
+            if (!this.itemDragHandler.isSlotDragged(slot1)) {
+                this.itemElement.render(slot1.getItemStack(), slot1.x, slot1.y, mouseOver, slot1);
+            }
+            if (mouseOver) {
+                slot = slot1;
+            }
+        }
+
+        final ContainerInventory containerInventory = this.mc.thePlayer.inventory;
+        ItemStack grabbedItem = containerInventory.getHeldItemStack();
+        if (this.mc.gameSettings.enableItemDragging.value) {
+            this.itemDragHandler.drawScreen(mx, my, partialTick);
+
+            ItemStack grabbedItemOverride = this.itemDragHandler.getHeldItemRenderOverride();
+            if (grabbedItemOverride != null) {
+                grabbedItem = grabbedItemOverride;
+            }
+        }
+        GLRenderer.popFrame();
+
+        super.render(mx, my, partialTick);
+
+        GLRenderer.pushFrame();
+        if (grabbedItem != null) {
+            GLRenderer.modelM4f().translate(centerX, centerY, 100.0F);
+            this.itemElement.render(grabbedItem, mx - centerX - 8, my - centerY - 8);
+        }
+        GLRenderer.popFrame();
+
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        if (containerInventory.getHeldItemStack() == null && slot != null && slot.hasItem()) {
+            boolean showDescription = DescriptionPromptEnum.showDescription(this.mc);
+            String str = this.tooltipElement.getTooltipText(slot.getItemStack(), showDescription, slot);
+            if (!str.isEmpty()) {
+                this.tooltipElement.render(str, mx, my, 8, -8);
+            }
+        }
+        GLRenderer.enableState(State.DEPTH_TEST);
+    }
+
+    public boolean getIsMouseOverSlot(final Slot slot, int i, int j) {
+        final int k = (this.width - this.xSize) / 2;
+        final int l = (this.height - this.ySize) / 2;
+        i -= k;
+        j -= l;
+        return i >= slot.x - 1 && i < slot.x + 16 + 1 && j >= slot.y - 1 && j < slot.y + 16 + 1;
+    }
+
+    public Slot getSlotAtPosition(final int i, final int j) {
+        for (int k = 0; k < this.inventorySlots.slots.size(); k++) {
+            final Slot slot = this.inventorySlots.slots.get(k);
+            if (getIsMouseOverSlot(slot, i, j)) {
+                return slot;
+            }
+        }
+
+        return null;
+    }
+
+    @Override
+    public void init() {
+        super.init();
+        this.mc.thePlayer.craftingInventory = this.inventorySlots;
+    }
+
+    @Override
+    public void keyPressed(final char eventCharacter, final int eventKey, int mx, int my) {
+        if (eventKey == Keyboard.KEY_ESCAPE || eventKey == Keyboard.KEY_BACK) {
+            this.mc.thePlayer.closeScreen();
+        }
+        int slotId = getSlotId(mx, my);
+        checkKeybind(slotId, eventKey, -1);
+    }
+
+    public boolean checkKeybind(int slotId, int key, int mouseButton) {
+        boolean cancelClick = false;
+        if (this.mc.gameSettings.keyInventory.isKeyOrMouse(key, mouseButton)) {
+            this.mc.thePlayer.closeScreen();
+            cancelClick = true;
+        }
+        if (slotId >= 0) {
+            if (this.mc.gameSettings.keyShowRecipe.isKeyOrMouse(key, mouseButton)) {
+                Slot slot = this.inventorySlots.slots.get(slotId);
+                if (slot.hasItem()) {
+                    String query = "r:" + slot.getItemStack().getDisplayName() + "!";
 //					removed();
 //					mc.thePlayer.closeScreen();
-					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
-					GuidebookPageSearch.searchField.setText(query);
-					ScreenGuidebook.getPageManager().updatePages();
-					if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.TROMMEL).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
-					}
-					mc.thePlayer.displayGuidebookScreen();
-				}
-				cancelClick = true;
-			}
-			if(mc.gameSettings.keyShowUsage.isKeyOrMouse(key, mouseButton)){
-				Slot slot = inventorySlots.slots.get(slotId);
-				if(slot.hasItem()) {
-					String query = "u:" + slot.getItemStack().getDisplayName() + "!";
+                    GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
+                    GuidebookPageSearch.searchField.setText(query);
+                    ScreenGuidebook.getPageManager().updatePages();
+                    if (!GuidebookSections.CRAFTING.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    } else if (!GuidebookSections.FURNACE.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
+                    } else if (!GuidebookSections.BLAST_FURNACE.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
+                    } else if (!GuidebookSections.TROMMEL.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
+                    }
+                    this.mc.thePlayer.displayGuidebookScreen();
+                }
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyShowUsage.isKeyOrMouse(key, mouseButton)) {
+                Slot slot = this.inventorySlots.slots.get(slotId);
+                if (slot.hasItem()) {
+                    String query = "u:" + slot.getItemStack().getDisplayName() + "!";
 //					removed();
 //					mc.thePlayer.closeScreen();
-					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
-					GuidebookPageSearch.searchField.setText(query);
-					ScreenGuidebook.getPageManager().updatePages();
-					if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
-					} else if (!((SearchableGuidebookSection) GuidebookSections.TROMMEL).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
-						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
-					}
-					mc.thePlayer.displayGuidebookScreen();
-				}
-				cancelClick = true;
-			}
-			if(mc.gameSettings.keyDrop.isKeyOrMouse(key, mouseButton)) {
-				boolean ctrl = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
-				int amount = 1;
-				if(ctrl) amount = 64;
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.DROP, new int[] {slotId, amount}, mc.thePlayer);
-				cancelClick = true;
-			}
-			// Horrifying
-			if (mc.gameSettings.keyHotBarSlot1.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 1}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot2.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 2}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot3.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 3}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot4.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 4}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot5.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 5}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot6.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 6}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot7.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 7}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot8.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 8}, mc.thePlayer);
-				cancelClick = true;
-			}
-			if (mc.gameSettings.keyHotBarSlot9.isKeyOrMouse(key, mouseButton)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 9}, mc.thePlayer);
-				cancelClick = true;
-			}
-
-			if(mc.gameSettings.keySortInventory.isKeyOrMouse(key, mouseButton)) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slotId}, mc.thePlayer);
-				cancelClick = true;
-			}
-		}
-		if (mc.currentScreen == this && mc.gameSettings.keyGuidebook.isKeyOrMouse(key, mouseButton)) {
-			mc.thePlayer.displayGuidebookScreen();
-			cancelClick = true;
-		}
-		return cancelClick;
-	}
-
-	@Override
-	public void mouseClicked(final int mx, final int my, int buttonNum)
-	{
-		if(!mc.thePlayer.getGamemode().consumeBlocks()) {
-			// Duplicate items with middle mouse button
-			if(buttonNum == 2) {
-				Slot slot = inventorySlots.getSlot(getSlotId(mx, my));
-				if (slot.getItemStack() == null) {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slot.index, 64}, mc.thePlayer);
-				} else {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, 64}, mc.thePlayer);
-				}
-				return;
-			}
-		}
-		if (checkKeybind(getSlotId(mx, my), -1, buttonNum)) return;
-		super.mouseClicked(mx, my, buttonNum);
-		if(mc.gameSettings.enableItemDragging.value) {
-			itemDragHandler.mouseEvent(mx, my, buttonNum, true);
-			return;
-		}
-		if (buttonNum == 0 || buttonNum == 1 || buttonNum == 2 || buttonNum == 10) //button == 10 = controller shift click
-		{
-			clickInventory(mx, my, buttonNum);
-		}
-	}
-	
-	@Override
-	public void mouseReleased(int mx, int my, int buttonNum) {
-		if(buttonNum >= 0) {
-			if(mc.gameSettings.enableItemDragging.value) {
-				itemDragHandler.mouseEvent(mx, my, buttonNum, false);
-			}
-		}
-		super.mouseReleased(mx, my, buttonNum);
-	}
-	
-	/**
-	 * This method controls what InventoryAction is sent to the server 
-	 */
-	public void clickInventory(int x, int y, int mouseButton) {
-		int slotId = getSlotId(x, y);
-
-		if(slotId == -1)
-			return;
-
-		if(slotId == -999) {
-			// Drop held item
-			InventoryAction action = InventoryAction.DROP_HELD_STACK;
-			if(mouseButton == 1) action = InventoryAction.DROP_HELD_SINGLE;
-			mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, action, null, mc.thePlayer);
-			return;
-		}
-		
-		if(!mc.thePlayer.getGamemode().consumeBlocks()) {
-			// Duplicate items with middle mouse button
-			if(mouseButton == 2) {
-				Slot slot = inventorySlots.getSlot(slotId);
-				if (slot.getItemStack() == null) {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slotId, 64}, mc.thePlayer);
-				} else {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slotId, 64}, mc.thePlayer);
-				}
-				return;
-			}
-		}
-		
-		InventoryAction action = InventoryAction.CLICK_LEFT;
-		
-		boolean shiftPressed = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
-		boolean ctrlPressed = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
-		boolean altPressed = Keyboard.isKeyDown(Keyboard.KEY_LMENU) || Keyboard.isKeyDown(Keyboard.KEY_RMENU);
-		boolean spacePressed = Keyboard.isKeyDown(Keyboard.KEY_SPACE);
-		
-		if(mouseButton == 10) { // Controller Shift click
-			// TODO replace with a nicer solution
-			shiftPressed = true;
-			mouseButton = 0;
-		}
-
-		if(mc.gameSettings.keySortInventory.isMouseButton(mouseButton)) {
-			action = InventoryAction.SORT;
-		}
-		
-		// Used by MOVE actions to determine where to move the items to.
-		// 0: default,
-		// 1: crafting grid in workbench and inventory
-		// 2: creative inventory in creative inventory
-		int target = 0; 
-
-		Slot slot = inventorySlots.getSlot(slotId);
-		ItemStack stackInSlot = slot != null ? slot.getItemStack() : null;
-		Item itemInSlot = stackInSlot != null ? stackInSlot.getItem() : null;
-		int clickedItemId = stackInSlot != null ? stackInSlot.getItem().id : 0;
-		ItemStack grabbedItem = mc.thePlayer.inventory.getHeldItemStack();
-		
-		if(mouseButton == 1) action = InventoryAction.CLICK_RIGHT;
-		
-		if(slot instanceof SlotResult) {
-			// Crafting behavior
-			if(mc.gameSettings.swapCraftingButtons.value) {
-				if(shiftPressed && ctrlPressed) {
-					action = InventoryAction.MOVE_SIMILAR;
-				}else if(shiftPressed) {
-					action = InventoryAction.MOVE_SINGLE_ITEM;
-				}else if(ctrlPressed){
-					action = InventoryAction.MOVE_STACK;
-				}
-			}else {
-				if(shiftPressed && ctrlPressed) {
-					action = InventoryAction.MOVE_SIMILAR;
-				}else if(shiftPressed) {
-					action = InventoryAction.MOVE_STACK;
-				}else if(ctrlPressed){
-					action = InventoryAction.MOVE_SINGLE_ITEM;
-				}
-			}
-		}else {
-			// Regular Slot behavior
-			if(spacePressed) {
-				action = InventoryAction.MOVE_ALL;
-			}else {
-				if(shiftPressed && ctrlPressed) {
-					action = InventoryAction.MOVE_SIMILAR;
-				}else if(shiftPressed || altPressed) {
-					action = InventoryAction.MOVE_STACK;
-				}else if(ctrlPressed) {
-					action = InventoryAction.MOVE_SINGLE_ITEM;
-				}
-			}
-		}
-		
-		if(slot instanceof SlotCreative) {
-			// Creative slot behavior
-			ItemStack heldItem = mc.thePlayer.inventory.getHeldItemStack();
-			
-			if(heldItem != null) {
-				if(heldItem.canStackWith(stackInSlot)) {
-					if(shiftPressed || ctrlPressed) {
-						mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, heldItem.getMaxStackSize()}, mc.thePlayer);
-					}else {
-						mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, heldItem.stackSize + 1}, mc.thePlayer);
-					}
-				}else {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, 0}, mc.thePlayer);
-				}
-			}else {
-				if(shiftPressed || ctrlPressed) {
-					int amount = 1;
-					if(shiftPressed && stackInSlot != null) amount = stackInSlot.getMaxStackSize();
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_MOVE, new int[] {slot.index, amount}, mc.thePlayer);
-				}else {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, 1}, mc.thePlayer);
-				}
-			}
-			return;
-		}
-
-		if(inventorySlots instanceof MenuInventory) {
-			if(itemInSlot instanceof IArmorItem) {
-				// Check for instanceof ItemArmor instead of canPutStackInSlot
-				// Pumpkins should not go into the armor slot when pressing shift
-				target = 2; // Into the armor slots
-			}
-		}
-		if(inventorySlots instanceof MenuFurnace) {
-			boolean isFuel, isIngredient = false;
-
-			for (RecipeEntryFurnace recipe : Registries.RECIPES.getAllFurnaceRecipes()) {
-				isIngredient = recipe.matches(stackInSlot);
-				if(isIngredient){
-					break;
-				}
-			}
-			isFuel = LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0;
-
-			if(isIngredient) {
-				target = 1; // Into the ingredient slot
-			}else if(isFuel) {
-				target = 2; // Into the fuel slot
-			}
-		}
-		if(inventorySlots instanceof MenuFurnaceBlast) {
-			boolean isFuel, isIngredient = false;
-
-			for (RecipeEntryBlastFurnace recipe : Registries.RECIPES.getAllBlastFurnaceRecipes()) {
-				RecipeSymbol[] input = recipe.getInput();
-				isIngredient = input[0].matches(stackInSlot);
-				if (input.length == 2) {
-					isIngredient |= input[1].matches(stackInSlot);
-				}
-				if(isIngredient){
-					break;
-				}
-			}
-			isFuel = LookupFuelFurnaceBlast.instance.getFuelYield(clickedItemId) > 0;
-
-			if(isIngredient) {
-				target = 1; // Into the ingredient slot
-			}else if(isFuel) {
-				target = 2; // Into the fuel slot
-			}
-		}
-		if(inventorySlots instanceof MenuTrommel) {
-			if(LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0) {
-				target = 2; // Into the fuel slot
-			}else {
-				target = 1; // Into the item slots
-			}
-		}
-		if(inventorySlots instanceof MenuCrafting || inventorySlots instanceof MenuInventory) {
-			// Move items into crafting by holding alt
-			
-			if(altPressed) target = 1; // Into the crafting grid
-		}
-		if(inventorySlots instanceof MenuInventoryCreative) {
-			// Delete items by holding alt in the creative inventory
-			
-			if(altPressed) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_DELETE, new int[] {slot.index}, mc.thePlayer);
-				return;
-			}
-		}
-		
-		// ContainerInventory Interactions (Grabbed Item)
-		if(slot != null && slot.allowItemInteraction() && grabbedItem != null && grabbedItem.getItem().hasInventoryInteraction()) {
-			if(mouseButton == 1) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.INTERACT_GRABBED, new int[] {slot.index}, mc.thePlayer);
-				return;
-			}
-		}
-		
-		// ContainerInventory Interactions (Clicked Item)
-		if(slot != null && stackInSlot != null && slot.allowItemInteraction() && stackInSlot.getItem().hasInventoryInteraction()) {
-			if(mouseButton == 1) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.INTERACT_SLOT, new int[] {slot.index}, mc.thePlayer);
-				return;
-			}
-		}
-		
-		int[] args = new int[] { slotId, target };
-		mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, action, args, mc.thePlayer);
-	}
-	public void controllerInput(@NotNull ControllerInput controller){
-		Slot slot = controller.getSlotAtCursor(this);
+                    GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
+                    GuidebookPageSearch.searchField.setText(query);
+                    ScreenGuidebook.getPageManager().updatePages();
+                    if (!GuidebookSections.CRAFTING.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    } else if (!GuidebookSections.FURNACE.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
+                    } else if (!GuidebookSections.BLAST_FURNACE.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
+                    } else if (!GuidebookSections.TROMMEL.searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+                        ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.TROMMEL), true);
+                    }
+                    this.mc.thePlayer.displayGuidebookScreen();
+                }
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyDrop.isKeyOrMouse(key, mouseButton)) {
+                boolean ctrl = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
+                int amount = 1;
+                if (ctrl) amount = 64;
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.DROP, new int[]{slotId, amount}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            // Horrifying
+            if (this.mc.gameSettings.keyHotBarSlot1.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 1}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot2.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 2}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot3.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 3}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot4.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 4}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot5.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 5}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot6.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 6}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot7.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 7}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot8.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 8}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+            if (this.mc.gameSettings.keyHotBarSlot9.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[]{slotId, 9}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+
+            if (this.mc.gameSettings.keySortInventory.isKeyOrMouse(key, mouseButton)) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.SORT, new int[]{slotId}, this.mc.thePlayer);
+                cancelClick = true;
+            }
+        }
+        if (this.mc.currentScreen == this && this.mc.gameSettings.keyGuidebook.isKeyOrMouse(key, mouseButton)) {
+            this.mc.thePlayer.displayGuidebookScreen();
+            cancelClick = true;
+        }
+        return cancelClick;
+    }
+
+    @Override
+    public void mouseClicked(final int mx, final int my, int buttonNum) {
+        if (!this.mc.thePlayer.getGamemode().consumeBlocks()) {
+            // Duplicate items with middle mouse button
+            if (buttonNum == 2) {
+                Slot slot = this.inventorySlots.getSlot(getSlotId(mx, my));
+                if (slot.getItemStack() == null) {
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.SORT, new int[]{slot.index, 64}, this.mc.thePlayer);
+                } else {
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slot.index, 64}, this.mc.thePlayer);
+                }
+                return;
+            }
+        }
+        if (checkKeybind(getSlotId(mx, my), -1, buttonNum)) return;
+        super.mouseClicked(mx, my, buttonNum);
+        if (this.mc.gameSettings.enableItemDragging.value) {
+            this.itemDragHandler.mouseEvent(mx, my, buttonNum, true);
+            return;
+        }
+        if (buttonNum == 0 || buttonNum == 1 || buttonNum == 2 || buttonNum == 10) //button == 10 = controller shift click
+        {
+            clickInventory(mx, my, buttonNum);
+        }
+    }
+
+    @Override
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        if (buttonNum >= 0) {
+            if (this.mc.gameSettings.enableItemDragging.value) {
+                this.itemDragHandler.mouseEvent(mx, my, buttonNum, false);
+            }
+        }
+        super.mouseReleased(mx, my, buttonNum);
+    }
+
+    /**
+     * This method controls what InventoryAction is sent to the server
+     */
+    public void clickInventory(int x, int y, int mouseButton) {
+        int slotId = getSlotId(x, y);
+
+        if (slotId == -1)
+            return;
+
+        if (slotId == -999) {
+            // Drop held item
+            InventoryAction action = InventoryAction.DROP_HELD_STACK;
+            if (mouseButton == 1) action = InventoryAction.DROP_HELD_SINGLE;
+            this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, action, null, this.mc.thePlayer);
+            return;
+        }
+
+        if (!this.mc.thePlayer.getGamemode().consumeBlocks()) {
+            // Duplicate items with middle mouse button
+            if (mouseButton == 2) {
+                Slot slot = this.inventorySlots.getSlot(slotId);
+                if (slot.getItemStack() == null) {
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.SORT, new int[]{slotId, 64}, this.mc.thePlayer);
+                } else {
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slotId, 64}, this.mc.thePlayer);
+                }
+                return;
+            }
+        }
+
+        InventoryAction action = InventoryAction.CLICK_LEFT;
+
+        boolean shiftPressed = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
+        boolean ctrlPressed = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
+        boolean altPressed = Keyboard.isKeyDown(Keyboard.KEY_LMENU) || Keyboard.isKeyDown(Keyboard.KEY_RMENU);
+        boolean spacePressed = Keyboard.isKeyDown(Keyboard.KEY_SPACE);
+
+        if (mouseButton == 10) { // Controller Shift click
+            // TODO replace with a nicer solution
+            shiftPressed = true;
+            mouseButton = 0;
+        }
+
+        if (this.mc.gameSettings.keySortInventory.isMouseButton(mouseButton)) {
+            action = InventoryAction.SORT;
+        }
+
+        // Used by MOVE actions to determine where to move the items to.
+        // 0: default,
+        // 1: crafting grid in workbench and inventory
+        // 2: creative inventory in creative inventory
+        int target = 0;
+
+        Slot slot = this.inventorySlots.getSlot(slotId);
+        ItemStack stackInSlot = slot != null ? slot.getItemStack() : null;
+        Item itemInSlot = stackInSlot != null ? stackInSlot.getItem() : null;
+        int clickedItemId = stackInSlot != null ? stackInSlot.getItem().id : 0;
+        ItemStack grabbedItem = this.mc.thePlayer.inventory.getHeldItemStack();
+
+        if (mouseButton == 1) action = InventoryAction.CLICK_RIGHT;
+
+        if (slot instanceof SlotResult) {
+            // Crafting behavior
+            if (this.mc.gameSettings.swapCraftingButtons.value) {
+                if (shiftPressed && ctrlPressed) {
+                    action = InventoryAction.MOVE_SIMILAR;
+                } else if (shiftPressed) {
+                    action = InventoryAction.MOVE_SINGLE_ITEM;
+                } else if (ctrlPressed) {
+                    action = InventoryAction.MOVE_STACK;
+                }
+            } else {
+                if (shiftPressed && ctrlPressed) {
+                    action = InventoryAction.MOVE_SIMILAR;
+                } else if (shiftPressed) {
+                    action = InventoryAction.MOVE_STACK;
+                } else if (ctrlPressed) {
+                    action = InventoryAction.MOVE_SINGLE_ITEM;
+                }
+            }
+        } else {
+            // Regular Slot behavior
+            if (spacePressed) {
+                action = InventoryAction.MOVE_ALL;
+            } else {
+                if (shiftPressed && ctrlPressed) {
+                    action = InventoryAction.MOVE_SIMILAR;
+                } else if (shiftPressed || altPressed) {
+                    action = InventoryAction.MOVE_STACK;
+                } else if (ctrlPressed) {
+                    action = InventoryAction.MOVE_SINGLE_ITEM;
+                }
+            }
+        }
+
+        if (slot instanceof SlotCreative) {
+            // Creative slot behavior
+            ItemStack heldItem = this.mc.thePlayer.inventory.getHeldItemStack();
+
+            if (heldItem != null) {
+                if (heldItem.canStackWith(stackInSlot)) {
+                    if (shiftPressed || ctrlPressed) {
+                        this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slot.index, heldItem.getMaxStackSize()}, this.mc.thePlayer);
+                    } else {
+                        this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slot.index, heldItem.stackSize + 1}, this.mc.thePlayer);
+                    }
+                } else {
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slot.index, 0}, this.mc.thePlayer);
+                }
+            } else {
+                if (shiftPressed || ctrlPressed) {
+                    int amount = 1;
+                    if (shiftPressed && stackInSlot != null) amount = stackInSlot.getMaxStackSize();
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_MOVE, new int[]{slot.index, amount}, this.mc.thePlayer);
+                } else {
+                    this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[]{slot.index, 1}, this.mc.thePlayer);
+                }
+            }
+            return;
+        }
+
+        if (this.inventorySlots instanceof MenuInventory) {
+            if (itemInSlot instanceof IArmorItem) {
+                // Check for instanceof ItemArmor instead of canPutStackInSlot
+                // Pumpkins should not go into the armor slot when pressing shift
+                target = 2; // Into the armor slots
+            }
+        }
+        if (this.inventorySlots instanceof MenuFurnace) {
+            boolean isFuel, isIngredient = false;
+
+            for (RecipeEntryFurnace recipe : Registries.RECIPES.getAllFurnaceRecipes()) {
+                isIngredient = recipe.matches(stackInSlot);
+                if (isIngredient) {
+                    break;
+                }
+            }
+            isFuel = LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0;
+
+            if (isIngredient) {
+                target = 1; // Into the ingredient slot
+            } else if (isFuel) {
+                target = 2; // Into the fuel slot
+            }
+        }
+        if (this.inventorySlots instanceof MenuFurnaceBlast) {
+            boolean isFuel, isIngredient = false;
+
+            for (RecipeEntryBlastFurnace recipe : Registries.RECIPES.getAllBlastFurnaceRecipes()) {
+                RecipeSymbol[] input = recipe.getInput();
+                isIngredient = input[0].matches(stackInSlot);
+                if (input.length == 2) {
+                    isIngredient |= input[1].matches(stackInSlot);
+                }
+                if (isIngredient) {
+                    break;
+                }
+            }
+            isFuel = LookupFuelFurnaceBlast.instance.getFuelYield(clickedItemId) > 0;
+
+            if (isIngredient) {
+                target = 1; // Into the ingredient slot
+            } else if (isFuel) {
+                target = 2; // Into the fuel slot
+            }
+        }
+        if (this.inventorySlots instanceof MenuTrommel) {
+            if (LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0) {
+                target = 2; // Into the fuel slot
+            } else {
+                target = 1; // Into the item slots
+            }
+        }
+        if (this.inventorySlots instanceof MenuCrafting || this.inventorySlots instanceof MenuInventory) {
+            // Move items into crafting by holding alt
+
+            if (altPressed) target = 1; // Into the crafting grid
+        }
+        if (this.inventorySlots instanceof MenuInventoryCreative) {
+            // Delete items by holding alt in the creative inventory
+
+            if (altPressed) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.CREATIVE_DELETE, new int[]{slot.index}, this.mc.thePlayer);
+                return;
+            }
+        }
+
+        // ContainerInventory Interactions (Grabbed Item)
+        if (slot != null && slot.allowItemInteraction() && grabbedItem != null && grabbedItem.getItem().hasInventoryInteraction()) {
+            if (mouseButton == 1) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.INTERACT_GRABBED, new int[]{slot.index}, this.mc.thePlayer);
+                return;
+            }
+        }
+
+        // ContainerInventory Interactions (Clicked Item)
+        if (slot != null && stackInSlot != null && slot.allowItemInteraction() && stackInSlot.getItem().hasInventoryInteraction()) {
+            if (mouseButton == 1) {
+                this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, InventoryAction.INTERACT_SLOT, new int[]{slot.index}, this.mc.thePlayer);
+                return;
+            }
+        }
+
+        int[] args = new int[]{slotId, target};
+        this.mc.playerController.handleInventoryMouseClick(this.inventorySlots.containerId, action, args, this.mc.thePlayer);
+    }
+
+    public void controllerInput(@NotNull ControllerInput controller) {
+        Slot slot = controller.getSlotAtCursor(this);
 
 //		if(joyLeft.stoppedMoving()) {
 //			if(slot != null) {
 //				snapToSlot(guiContainer, slot);
 //			}
 //		}
-		if(slot != null) {
-			if(controller.digitalPad.right.pressedThisFrame()) {
-				Slot slot3 = null;
-				//Get Next Slot to the right
-				for(Slot slot2 : inventorySlots.slots) {
-					if(slot2.x > slot.x && Math.abs(slot2.y - slot.y) < 12) {
-						if(slot3 == null || slot2.x < slot3.x) {
-							slot3 = slot2;
-						}
-					}
-				}
-				if(slot3 == null) {
-					//Get First Slot on the left
-					for(Slot slot2 : inventorySlots.slots) {
-						if(Math.abs(slot2.y - slot.y) < 12) {
-							if(slot3 == null || slot2.x < slot3.x) {
-								slot3 = slot2;
-							}
-						}
-					}
-				}
-				controller.snapToSlot(this, slot3);
-			}
-			if(controller.digitalPad.left.pressedThisFrame()) {
-				Slot slot3 = null;
-				//Get Next Slot to the left
-				for(Slot slot2 : this.inventorySlots.slots) {
-					if(slot2.x < slot.x && Math.abs(slot2.y - slot.y) < 12) {
-						if(slot3 == null || slot2.x > slot3.x) {
-							slot3 = slot2;
-						}
-					}
-				}
-				if(slot3 == null) {
-					//Get First Slot on the right
-					for(Slot slot2 : this.inventorySlots.slots) {
-						if(Math.abs(slot2.y - slot.y) < 12) {
-							if(slot3 == null || slot2.x > slot3.x) {
-								slot3 = slot2;
-							}
-						}
-					}
-				}
-				controller.snapToSlot(this, slot3);
-			}
-			if(controller.digitalPad.up.pressedThisFrame()) {
-				Slot slot3 = null;
-				//Get Next Slot up
-				for(Slot slot2 : this.inventorySlots.slots) {
-					if(slot2.y < slot.y && Math.abs(slot2.x - slot.x) < 12) {
-						if(slot3 == null || slot2.y > slot3.y) {
-							slot3 = slot2;
-						}
-					}
-				}
-				if(slot3 == null) {
-					//Get First Slot on the bottom
-					for(Slot slot2 : this.inventorySlots.slots) {
-						if(Math.abs(slot2.x - slot.x) < 12) {
-							if(slot3 == null || slot2.y > slot3.y) {
-								slot3 = slot2;
-							}
-						}
-					}
-				}
-				controller.snapToSlot(this, slot3);
-			}
-			if(controller.digitalPad.down.pressedThisFrame()) {
-				Slot slot3 = null;
-				//Get Next Slot down
-				for(Slot slot2 : this.inventorySlots.slots) {
-					if(slot2.y > slot.y && Math.abs(slot2.x - slot.x) < 12) {
-						if(slot3 == null || slot2.y < slot3.y) {
-							slot3 = slot2;
-						}
-					}
-				}
-				if(slot3 == null) {
-					//Get First Slot on the top
-					for(Slot slot2 : this.inventorySlots.slots) {
-						if(Math.abs(slot2.x - slot.x) < 12) {
-							if(slot3 == null || slot2.y < slot3.y) {
-								slot3 = slot2;
-							}
-						}
-					}
-				}
-				controller.snapToSlot(this, slot3);
-			}
-		}
+        if (slot != null) {
+            if (controller.digitalPad.right.pressedThisFrame()) {
+                Slot slot3 = null;
+                //Get Next Slot to the right
+                for (Slot slot2 : this.inventorySlots.slots) {
+                    if (slot2.x > slot.x && Math.abs(slot2.y - slot.y) < 12) {
+                        if (slot3 == null || slot2.x < slot3.x) {
+                            slot3 = slot2;
+                        }
+                    }
+                }
+                if (slot3 == null) {
+                    //Get First Slot on the left
+                    for (Slot slot2 : this.inventorySlots.slots) {
+                        if (Math.abs(slot2.y - slot.y) < 12) {
+                            if (slot3 == null || slot2.x < slot3.x) {
+                                slot3 = slot2;
+                            }
+                        }
+                    }
+                }
+                controller.snapToSlot(this, slot3);
+            }
+            if (controller.digitalPad.left.pressedThisFrame()) {
+                Slot slot3 = null;
+                //Get Next Slot to the left
+                for (Slot slot2 : this.inventorySlots.slots) {
+                    if (slot2.x < slot.x && Math.abs(slot2.y - slot.y) < 12) {
+                        if (slot3 == null || slot2.x > slot3.x) {
+                            slot3 = slot2;
+                        }
+                    }
+                }
+                if (slot3 == null) {
+                    //Get First Slot on the right
+                    for (Slot slot2 : this.inventorySlots.slots) {
+                        if (Math.abs(slot2.y - slot.y) < 12) {
+                            if (slot3 == null || slot2.x > slot3.x) {
+                                slot3 = slot2;
+                            }
+                        }
+                    }
+                }
+                controller.snapToSlot(this, slot3);
+            }
+            if (controller.digitalPad.up.pressedThisFrame()) {
+                Slot slot3 = null;
+                //Get Next Slot up
+                for (Slot slot2 : this.inventorySlots.slots) {
+                    if (slot2.y < slot.y && Math.abs(slot2.x - slot.x) < 12) {
+                        if (slot3 == null || slot2.y > slot3.y) {
+                            slot3 = slot2;
+                        }
+                    }
+                }
+                if (slot3 == null) {
+                    //Get First Slot on the bottom
+                    for (Slot slot2 : this.inventorySlots.slots) {
+                        if (Math.abs(slot2.x - slot.x) < 12) {
+                            if (slot3 == null || slot2.y > slot3.y) {
+                                slot3 = slot2;
+                            }
+                        }
+                    }
+                }
+                controller.snapToSlot(this, slot3);
+            }
+            if (controller.digitalPad.down.pressedThisFrame()) {
+                Slot slot3 = null;
+                //Get Next Slot down
+                for (Slot slot2 : this.inventorySlots.slots) {
+                    if (slot2.y > slot.y && Math.abs(slot2.x - slot.x) < 12) {
+                        if (slot3 == null || slot2.y < slot3.y) {
+                            slot3 = slot2;
+                        }
+                    }
+                }
+                if (slot3 == null) {
+                    //Get First Slot on the top
+                    for (Slot slot2 : this.inventorySlots.slots) {
+                        if (Math.abs(slot2.x - slot.x) < 12) {
+                            if (slot3 == null || slot2.y < slot3.y) {
+                                slot3 = slot2;
+                            }
+                        }
+                    }
+                }
+                controller.snapToSlot(this, slot3);
+            }
+        }
 
 //		if(controller.buttonR.pressedThisFrame()) {
 //			slot = controller.getSlotAtCursor(this);
